
let rec intervalle r a b =
  if a > b then r
  else intervalle2 (a::r) (a+1) b

and intervalle2 r a b =
  if a > b then []
  else intervalle (a::r) (a+1) b

let intervalle a b = intervalle [] a b 


module SafeThread :
sig
  type t
  val create : ('a -> 'b) -> 'a -> t
  val join : t -> unit
end =
  Thread



let compute size n il =
  let threads = ref [] in
  let vectors = Array.make n [||] in
    for i = 1 to n do
      threads := (
	Printf.printf "Thread creation <%d>\n" i;
	flush stdout;
	SafeThread.create
	  begin fun () ->
	    let v = Array.make size 0 in
	      vectors.(i-1) <- v;
	      for j = 0 to size - 1 do
		if j mod (size / 10) = 0 then
		  (Printf.printf "Thread <%d> says it is alive / iteration # <%d>\n" i (j / (size/10)); flush stdout);
		v.(j) <- j;
		intervalle 0 il
	      done;
	      Printf.printf "Thread death <%d>\n" i;
	      flush stdout;
	  end
	  ()
      ) :: !threads 
    done;
    List.iter SafeThread.join !threads;
    Printf.printf "All threads should be joined!\n";
    flush stdout;
    Array.iteri 
      begin fun i v ->
	if i > 0 && i < Array.length v then
	  if v.(i) <> v.(i-1) + 1 then
	    (Printf.printf "problem with an array, at index %d\n" i ;
	     assert false)
	  else
	    ()
      end
      vectors
    
let _ =
  compute 10_000 3 10_000;
(*
  print_endline "main thread computing start";
  for i = 0 to 100_000 do
    ignore(intervalle 0 1000);
  done;
  print_endline "main thread computing end"; 
*)
  print_endline "Exit !"
    
