open Unix

type t = {
  thread : Thread.t;
  mutex : Mutex.t;
}
let thread_create f a =
  let m = Mutex.create () in
  let () = Mutex.lock m in
    {
      thread = Thread.create
	(fun () -> try f a ; Mutex.unlock m with e -> Mutex.unlock m ; raise e)
	();
      mutex = m
    }
let thread_join t =
  Mutex.lock t.mutex;
  Mutex.unlock t.mutex

let thread_create = Thread.create
let thread_join = Thread.join


let mkmatrix rows cols =
    let count = ref 1.0
    and last_col = cols - 1
    and m = Array.make_matrix rows cols 42. in
      (*
  for i = 0 to rows - 1 do
    let mi = m.(i) in
      for j = 0 to last_col do
      mi.(j) <- !count;
      count:= !count *. 1.77 
    done;
  done;
      *)
  m

let rec inner_loop k v m1i m2 j =
  if k < 0 then v
  else inner_loop (k - 1) (v +. m1i.(k) *. m2.(k).(j)) m1i m2 j

let listTh = ref []

let mmult rows col =
  let last_row = rows - 1 in
  let last_col = col - 1 in
  let cpt = ref 0 in
  let join_all ths =
    List.iter (fun e -> thread_join e ; (*print_endline "Thread joined"*)) !ths ;
    ths := []
  in
    for i = 0 to last_row do
	if !cpt mod int_of_string Sys.argv.(2) = 0 then
	  join_all listTh;
	incr cpt;
	listTh := 
	  thread_create 
	    (fun () ->
	       (*print_endline "Thread creation";*)
	       Printf.printf " Thread %d begins computation\n" (Thread.id (Thread.self()));

	       flush Pervasives.stdout;
	       for j = 0 to last_col do
		(* m3i.(j) <- inner_loop last_row 0. m1i m2 j;*)
		 ignore(Array.make_matrix 10 10 42);
	       done;
	       Printf.printf "Thread %d ends calculation\n" (Thread.id (Thread.self()));

	       flush Pervasives.stdout;
	       (*print_endline "Thread death";*)
	    )
            ()
	::(!listTh);
    done;
    List.iter thread_join !listTh

let t1 = ref (Unix.times ())
let t2 = ref (Unix.times ())

let _ =
  let size = int_of_string Sys.argv.(1) in
(*  let m1 = mkmatrix size size
  and m2 = mkmatrix size size
  and m3 = Array.make_matrix size size 0. in*)
  (
    t1 := Unix.times ();
    let ta = Unix.gettimeofday () in
      (    
	mmult size size;
	t2 := Unix.times ();
	let tb = Unix.gettimeofday () in
	  Printf.printf "Temp de calcul: utime %f, stime %f, rtime %f\n" (!t2.tms_utime -. !t1.tms_utime) (!t2.tms_stime-. !t1.tms_stime) (tb -. ta);
      );
  )
